function [ar,emax,emin] = ar3d(xnod,icone)
%
%   [ar,emax,emin] = ar3d(xnod,icone)
%
%   ar : aspect ratio
%   emin : minimal edge length element by element
%   emax : maximal edge length element by element
%

ar=[]; dsth=[];
[numel,nen]=size(icone);
[nnod,ndm]=size(xnod);

if nen==3,
 edges = [1,2 ; 2,3 ; 3,1];
elseif (nen==4)&(ndm==2),
 edges = [1,2 ; 2,3 ; 3,4 ; 4,1];
elseif (nen==4)&(ndm==3),
 edges = [1,2 ; 2,3 ; 3,1 ; 1,4 ; 2,4 ; 3,4];
elseif nen==8,
 edges = [1,2 ; 2,3 ; 3,4 ; 4,1 ; 
          5,6 ; 6,7 ; 7,8 ; 8,5 ; 
		  1,5 ; 2,6 ; 3,7 ; 4,8 ];
else
  error(' Error in the type of element')
end

n_edges = length(edges(:,1));

for iedge=1:n_edges,
  nodo_1 = icone(:,edges(iedge,1));
  nodo_2 = icone(:,edges(iedge,2));
  dst = (xnod(nodo_2,:)-xnod(nodo_1,:));
  dst = sqrt(sum(dst'.^2))';
  dsth =[dsth,dst];
end

emin = min(dsth')';
emax = max(dsth')';

ar = emax ./ emin;

return

